#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QMap>
#include <QList>

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

private slots:
    void on_pushButton_iptable_clicked();
    void on_pushButton_gen_clicked();
    void on_actionAbout_QT_triggered();
    void on_actionAbout_any2sns_triggered();
    void on_action_Quit_triggered();
    void on_pushButton_clicked();
    void on_pushButton_xml1_clicked();
    void on_pushButton_eol_clicked();
    void on_comboBox_highlighted(const QString &src);

    void on_pushButton_2_clicked();

private:
    Ui::MainWindow *ui;
    QMap<QString, QString> map_host;
    QMap<QString, QString> map_net;
    QMap<QString, QString> map_eole_var;
    QMap<QString, QStringList> map_eole_table;
    QList<QString> list_service;

    void extract_from_iptable();
    void extract_from_xml1();
    void extract_interfaces();
    void extract_services();
    void extract_rules();


    void extract_from_eol();
    void extract_dns();
    void extract_ip();

    quint8 netmask_to_cidr(const QString &mask);

    void text_highlight(const QString &searchString);
    void line_highlight();

    void hide_layout(QLayout *ql);
    void show_layout(QLayout *ql);

    enum IfType {IF_LO, IF_ETH, IF_VLAN};
    enum StreanDirection {UP=0, DOWN};

    int cnt_filter, cnt_nat, cnt_if, cnt_services, cnt_services_group, cnt_host, cnt_net;
    int cnt_eol_val, cnt_eol_table;
};

#endif // MAINWINDOW_H
